/* Copyright (C) 1994 Queen Mary and Westfield College, University of London

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License may be found in
   doc/COPYING in the source tree of this programm.

   This file was written by: Franz Gerschwiler. (goblin@dcs.qmw.ac.uk)

 ****

   modified by: p.hlstede	(peter@calvados.chemie.uni-bremen.de)

   - the code was reorganized and ansified
   - modified to work with the undo-code from asedit

							06.09.1997
 */

#include <Xm/Xm.h>
#include <Xm/Text.h>

#include "globals.h"
#include "callbacks.h"
#include "undo.h"

void  cut_copyCB(Widget w, XtPointer client_data, XtPointer call_data)
{
   int      reason = (int)client_data;
   XEvent  *event = ((XmPushButtonCallbackStruct *)call_data)->event;
   Time     when;

   if (event != NULL)
   {
      switch (event->type)
      {
	 case ButtonRelease:
	    when = event->xbutton.time;
	    break;

	 case KeyRelease:
	    when = event->xkey.time;
	    break;

	 default:
	    when = CurrentTime;
	    break;
      }
   }
   else
      when = CurrentTime;

   switch (reason)
   {
      case 0:
	 XmTextCut(text_canvas, when);
	 break;

      case 1:
	 XmTextCopy(text_canvas, when);
	 break;
   }
}

void  gui_pasteCB(Widget w, XtPointer client_data, XtPointer call_data)
{
   XmTextPaste(text_canvas);
}

void  gui_undoCB(Widget w, XtPointer client_data, XtPointer call_data)
{
   UndoRedo((int)client_data);
}
